#!/usr/bin/env node
"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const salesforce_microservice_1 = require("./microservices/salesforce.microservice");
const grpc = __importStar(require("grpc"));
const logger_factory_1 = require("./logger.factory");
const globalLogger = logger_factory_1.loggerFactory();
if (!(process.env.SF_ENV &&
    process.env.SF_URL &&
    process.env.SF_USER &&
    process.env.SF_PASS)) {
    globalLogger.error('Missing environment variables');
    process.exit(1);
}
const microservice = new salesforce_microservice_1.SalesforceMicroservice(process.env);
const port = process.env.PORT || 8888;
const server = new grpc.Server({
    'grpc.max_send_message_length': 1024 * 1024 * 1024,
    'grpc.max_receive_message_length': 1024 * 1024 * 1024,
});
server.addService(microservice.service, microservice);
server.bind(`0.0.0.0:${port}`, grpc.ServerCredentials.createInsecure());
server.start();
globalLogger.info(`SalesforceMicroservice is listening on port ${port}.`);
//# sourceMappingURL=app.js.map