"use strict";
// from gcanti/fp-ts. All credit to them
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @function
 * @since 1.0.0
 */
// tslint:disable-next-line:ban-types
function pipe(...fns) {
    const len = fns.length - 1;
    return function (x) {
        let y = x;
        for (let i = 0; i <= len; i++) {
            y = fns[i].call(this, y);
        }
        return y;
    };
}
exports.pipe = pipe;
exports.tuple = (a, b) => [a, b];
/**
 * Apply a function to pairs of elements at the same index in two arrays, collecting the results in a new array. If one
 * input array is short, excess elements of the longer array are discarded.
 * @function
 * @since 1.0.0
 */
exports.zipWith = (fa, fb, f) => {
    const fc = [];
    const len = Math.min(fa.length, fb.length);
    for (let i = 0; i < len; i++) {
        fc[i] = f(fa[i], fb[i]);
    }
    return fc;
};
/**
 * Takes two arrays and returns an array of corresponding pairs. If one input array is short, excess elements of the
 * longer array are discarded
 * @function
 * @since 1.0.0
 */
exports.zip = (fa, fb) => exports.zipWith(fa, fb, exports.tuple);
exports.flatten = (fa) => fa.reduce((p, c) => [...p, ...c], []);
exports.split = (sequence) => (s) => s.split(sequence);
//# sourceMappingURL=fp.js.map