export interface LoggerFactoryOptions {
    /** path to a log file */
    path?: string;
    /** name of the log file */
    name?: string;
    /** default log level */
    level?: 'silly' | 'debug' | 'verbose' | 'info' | 'warn' | 'error';
}
/**
 * Creates an instance of the winston logger that writes to stdout and a file
 * @param options A file to write to or an options object
 */
export declare const loggerFactory: (options?: string | LoggerFactoryOptions | undefined) => import("winston").Logger;
//# sourceMappingURL=logger.factory.d.ts.map