import * as jsforce from 'jsforce';
import { QueryRequest, IdRequest, RecordsRequest, UpsertRequest, SearchRequest, JSONObject } from '@shingo/sf-api-shared';
export declare class SalesforceService {
    private conn;
    private log;
    private auditLog;
    private queryRunner;
    constructor(SF_URL: string, SF_ENV: string, SF_USER: string, SF_PASS: string, conn?: jsforce.Connection, log?: import("winston").Logger, auditLog?: import("winston").Logger);
    query(queryRequest: QueryRequest): Promise<JSONObject>;
    retrieve(idRequest: IdRequest): Promise<JSONObject>;
    create(recordsRequest: RecordsRequest): Promise<JSONObject>;
    update(recordsRequest: RecordsRequest): Promise<JSONObject>;
    delete(idRequest: IdRequest): Promise<JSONObject>;
    upsert(request: UpsertRequest): Promise<JSONObject>;
    describe(object: string): Promise<JSONObject>;
    search(searchRequest: SearchRequest): Promise<JSONObject>;
}
//# sourceMappingURL=salesforce.service.d.ts.map